#include "settings.h"
 
namespace Q
{

    Settings::Settings(const char* filename)
    {
	container=new SettingsContainer;
	this->filename=NULL;
    	readsuccess=false;

	container->insert(SettingsElement("proxy",""));
	container->insert(SettingsElement("port",""));
	container->insert(SettingsElement("user",""));
	container->insert(SettingsElement("pass",""));

	if(filename!=NULL)
	{
	    std::ifstream infile(filename);

	    if(infile.good())
	    {
    		try
    		{
        	    std::string str;
        	    while(std::getline(infile,str))
        	    {
                	str=trim(str);
			if(str.find(" ")!=std::string::npos)
		        {
		    	    std::string first,second;
			    first=str.substr(0,str.find(" "));
			    second=str.substr(str.find(" ")+1,str.length()-str.find(" ")-1);
			    second=trim(second);
			    (*container)[first]=second;
			}
			else 
			    (*container)[str]="";
//			    throw("Config file format error");
        	    }
    		}
    		catch(std::ios_base::failure &var)
    		{
        	    throw ((char*)var.what());
    		}
		readsuccess=true;
	    }
	    this->filename=new std::string;
	    *(this->filename)=filename;
	}
    }

    std::string& Settings::operator[](const std::string& id) const
    {
        return (*container)[id];
    }

    int Settings::count(const std::string& id) const
    {
	return container->count(id);
    }
    
    bool Settings::read()
    {
	return readsuccess;
    }

    Settings::~Settings()
    {
    	if(this->filename!=NULL)
    	{
	    std::ofstream outfile(filename->c_str());
	    for(SettingsContainer::iterator i=container->begin();i!=container->end();i++)
		outfile<<i->first<<" "<<i->second<<std::endl;
	}
	delete container;
    }

    std::string Settings::trim(std::string s)
    {
	// replace tabs with spaces
	for(register unsigned int i=0;i<s.length();i++)
	    if(s[i]=='\t')
		s[i]=' ';

	// remove leading spaces
        while(s[0]==' ')
            s.erase(0,1);

	// remove tailing spaces
        while(s[s.length()-1]==' ')
            s.erase(s.length()-1,1);

        return s;
    }
}
